#!/usr/bin/perl
#---------------------------------------------------------------------------------------------------------------
use strict;
use warnings;
use GD;
#use Data::Dumper;

our $look='none-at-all';
our $dbh;

my $rand_seed = time ^ ($$ + ($$ << 15));
my $difficulty =1; #= $ENV{QUERY_STRING} eq '1' ? 1 : $ENV{QUERY_STRING} eq '3' ? 3 : 2;
my $entry_id;

#if ($ENV{HTTP_COOKIE} && $ENV{HTTP_COOKIE}=~/control_image=(\d+)/) {
#    $entry_id = $1;
#    my $dbentry = $dbh->selectrow_array(qq[SELECT value FROM control_images WHERE id_img=?], undef, $entry_id);
#    if ($dbentry) {
#	if ($dbentry=~/\bseed=(\d+)\b/) {
#	    $rand_seed = $1;
#	}
#	if ($dbentry=~/\bdifficulty=(\d)\b/) {
#	    $difficulty = $1;
#	}
#    } else {
#	$entry_id = undef;
#    }
#}

##my $dbentry = $dbh->selectrow_array(qq[DELETE FROM control_images WHERE id_img=?], undef, $entry_id);
srand($rand_seed);

my $WIDTH  = 900;						# (maximal) dimensions of resulting image and temporary canvases
my $HEIGHT = 200;
my @bg_color = (255,255,255);					# color of image background
my @fg_color = (int(rand(40)), int(rand(60)), int(rand(80)));	# color of formula brush
my $font  = "fonts/Chiller.ttf";				# font for formula
my $font2 = "fonts/Bauhs93.ttf";				# font for watermarks text
my $f_size    = 24;						# formula font size (in pt)
my $f2_size   = 26;						# watermarks text font size
my $f_sup     = 0.7;						# downscale for subscripts / superscripts
my $f_supover = 0.3;						# minimal superscript distance from the baseline
my ($img_dash,$img_root); # internal use
my @letters = qw[x x x y y z z z s p];
my $x = $letters[rand(@letters)];

srand();

my $sample=int(rand(89999))+10000;

#------- Generate formula and store it into DB/cookie environment -------------------------------------------------
my ($formula, $answer) = make_formula($difficulty);
##my ($formula,$answer)=("$sample",int($sample));
##print Dumper($formula);
##print $answer;

my $img = make_image($formula);
#&::debug_into_base($img);

##unless ($entry_id) {
##    #debugdb("seed=$rand_seed;answer=$answer;difficulty=$difficulty");
##    $dbh->do(qq[INSERT INTO control_images(value) VALUES(?)], undef, "seed=$rand_seed;answer=$answer;difficulty=$difficulty");
##    $dbh->commit();
##    $entry_id = $dbh->selectrow_array(q[SELECT @@IDENTITY]);
##}
##print "Set-Cookie: control_image=$entry_id; secure\n";
print "Content-Type: image/pjpeg\n";
print "Content-Transfer-Encoding: binary\n\n";
binmode STDOUT;
print $img->jpeg();

1;

#------------------------------------------------------------------------------------------------------------------
# Generate random formula
#------------------------------------------------------------------------------------------------------------------
sub make_formula {
    my $deg = shift;
    my($numerator,   @nseries) = make_Ox($deg);
    my($denominator, @dseries) = make_Ox($deg);
    my $tokens = [{type=>"frac", above=>$numerator, below=>$denominator}];
    my $answer = $nseries[$deg]/$dseries[$deg];
    if(.3>rand && $difficulty>1){
	unshift @$tokens, "-" if $answer<0;
	$tokens = [{type=>"sqrt", below=>$tokens}];
	$answer = sqrt(abs($answer));
	}
    unshift @$tokens, {type=>"under", above=>"lim", below=>"$x->0"};
    return($tokens, sprintf("%.3f", $answer));
    }

sub make_Ox {
    my $n = shift; # works with $n<=3
    my @degs = (0..$n-1);
    my($code1, @s1) = make_Ox0();
    my($code2, @s2) = make_Ox0();
    my($A, $B);
    foreach (reverse @degs){
	next unless $s1[$_] && $s2[$_];
	$A = 8*$s2[$_]; $B = -8*$s1[$_];
	last;
	}
    if(!defined $A && !defined $B){
	$A = $B = 0;
	while($A==0 || $B==0){ $A = int(rand(10)-4); $B = int(rand(10)-4); }
	}
    while($A%2==0 && $B%2==0){ $A/=2; $B/=2; }
    while($A%3==0 && $B%3==0){ $A/=3; $B/=3; }
    while($A%5==0 && $B%5==0){ $A/=5; $B/=5; }
    while($A%7==0 && $B%7==0){ $A/=7; $B/=7; }
    my($res, @ser);
    $res = [($A==1?'':$A==-1?'-':$A), @$code1, ($B==1?"+":$B==-1?"-":$B>0?"+$B":$B), @$code2];
    $ser[$_] = $A*$s1[$_]+$B*$s2[$_] foreach(0..$#s1);
    foreach my $i (@degs){
	my $c = -$ser[$i];
	$c/=2 if $i==2; # in fact, it should be $i!
	next if $c==0;
	push @$res, $c>0?"+$c":$c if $i==0;
	push @$res, ($c==1?"+":$c==-1?"-":$c>0?"+$c":$c). $x if $i>=1;
	push @$res, {type=>'sup', above=>'2'} if $i==2;
	$ser[$i] = 0;
	}
    return $ser[$n]==0 ? make_Ox($n) : ($res, @ser);
    }

sub make_Ox0 {
    my $prob = .3;
    my($res, @ser);
    my $skip = [];
    while(1){
	my($term, @series) = get_term($skip);
	if((ref $term->[0] || $term->[0]=~/^[^\d-]/) && .3>rand){
	    my $a = int(rand(3)+2);
	    unshift @$term, $a;
	    $_*=$a foreach(@series);
	    }
	if(!defined $res){
	    $res = $term;
	    @ser = @series;
	    }
	else{
	    if(ref $term->[0]){ push @$res, ("+", @$term); }
	    else{
		$term->[0] = "+$term->[0]" unless substr($term->[0],0,1) eq '-';
		push @$res, @$term;
		}
	    $ser[$_]+=$series[$_] foreach(0..$#series);
	    }
	$prob += .3 if $prob<.7; last if $prob>rand;
	}
    # check if the only thing added was a constant, then redo...
    my $flag = $skip->[0];
    foreach (2..20){
	$flag = 0 if $skip->[$_];
	}
    return make_Ox0() if $flag;

    # now apply certain nested functioning...
    my $rnd = rand;
    if($rnd<.25){    #do nothing
	unshift @$res, "(";
	push @$res, ")";
	}
    elsif($rnd<.50){ #square
	unshift @$res, "(";
	push @$res, ")", {type=>'sup', above=>'2'};
	@ser = ($ser[0]**2, 2*$ser[0]*$ser[1], 2*$ser[1]**2+2*$ser[0]*$ser[2], 6*$ser[1]*$ser[2]+2*$ser[0]*$ser[3]);
	}
    elsif($rnd<.75){ #sqrt
	if($ser[0]!=1){
	    my $d = 1-$ser[0];
	    push @$res, ($d>0?"+":"-"), {type=>'frac', above=>abs($d), below=>"$x+1"};
	    @ser = ($ser[0]+$d, $ser[1]-$d, $ser[2]+2*$d, $ser[3]-6*$d);
	    }
	$res = [{type=>'sqrt', below=>$res}];
	@ser = (1, 1/2*$ser[1], 1/4*(-$ser[1]**2+2*$ser[2]), 1/8*(3*$ser[1]**3-6*$ser[1]*$ser[2]+4*$ser[3]));
	}
    elsif($rnd<1.0){ #ln
	if($ser[0]!=1){
	    my $d = 1-$ser[0];
	    push @$res, ($d>0?"+":"-"), {type=>'frac', above=>abs($d), below=>"1-$x"};
	    @ser = ($ser[0]+$d, $ser[1]+$d, $ser[2]+2*$d, $ser[3]+6*$d);
	    }
	unshift @$res, "ln(";
	push @$res, ")";
	@ser = (0, $ser[1], -$ser[1]**2+$ser[2], 2*$ser[1]**3-3*$ser[1]*$ser[2]+$ser[3]);
	}
    return($res, @ser);
    }

sub get_term {
    my $skip = shift;
    my $sqr = {type=>"sup", above=>"2"};
    my $a = int(rand(3)+1);
    my @t = (
	# frequency, code, series
	# some explanation is necessary here: if the series is c0 + c1*x + 1/2!*c2*x^2 + 1/3!*c3*x^3 + ...
	# then actually stored values are (c0, c1, c2, c3, ...). This is done to avoid dealing with rational numbers.
	# actually, this allows us to avoid fractions everywhere except in sqrt[1+f[x]], but even there the fractions are
	# tolerable as they are powers of two: .5, .25 and .125
	[1,   [$a], $a, 0, 0, 0],
	[.5,  [-$a], -$a, 0, 0, 0],
	[1,   ["sin$x"], 0, 1, 0, -1],
	[1,   ["cos$x"], 1, 0, -1, 0],
	[.3,  ["sin2$x"], 0, 2, 0, -8],
	[.3,  ["cos2$x"], 1, 0, -4, 0],
	[1,   ["tg$x"], 0, 1, 0, 2],
	[.5,  ["sin",$sqr,$x], 0, 0, 2, 0],
	[.6,  ["cos",$sqr,$x], 1, 0, -2, 0],
	[2,   ["e",{type=>"sup",above=>$x}], 1, 1, 1, 1],
	[.6,  [$x], 0, 1, 0, 0],
	[.5,  [$x,$sqr], 0, 0, 2, 0],
	[.5,  ["(1+$x)",{type=>"sup",above=>$x}], 1, 0, 2, -3],
	);
    my $sum = 0;
    foreach(0..$#t){
	$sum += $t[$_][0] unless $skip->[$_];
	}
    my $rnd = rand($sum);
    foreach(0..$#t){
	next if $skip->[$_];
	$rnd -= $t[$_][0];
	next if $rnd>0;
	$skip->[0] = $skip->[1] = 1 if $_==0 || $_==1;
	$skip->[7] = $skip->[8] = 1 if $_==7 || $_==8;
	$skip->[$_] = 1;
	return @{$t[$_]}[1..5];
	}
    }

#------------------------------------------------------------------------------------------------------------------
# Generate image
#------------------------------------------------------------------------------------------------------------------
sub make_image
    {

    my $tokens = shift;
    my($img, @rec) = print_tokens($tokens);
    my $width = $rec[2]+40;
    my $height = $rec[3]+6;
    my $img_out = new GD::Image($width, $height, 1);
    $img_out->filledRectangle(0,0,$width-1,$height-1, $img_out->colorAllocate(255,255,255));
    $img_out->copy($img, 20,3, $rec[0],$rec[1]-$rec[4], $rec[2],$rec[3]);

    # add some noise
    my $c1 = $img->colorAllocate(@bg_color); # reuse $img for other drawings
    my $c2 = $img->colorAllocate(@fg_color);
    $img->transparent($c1);
    foreach ("keep smiling", "be happy", ";)", "^_^", "(:", "%)", '@_@'){
	next if .2>rand;
	$img->filledRectangle(0,0,$WIDTH-1,$HEIGHT-1,$c1);
	my $angle = .2*rand;
	my @b = $img->stringFT($c2, $font2, $f2_size, $angle, 20,$angle>0?$HEIGHT-30:30, $_);
	my @rec = (MIN($b[0],$b[2],$b[4],$b[6]), MIN($b[1],$b[3],$b[5],$b[7]), MAX($b[0],$b[2],$b[4],$b[6]), MAX($b[1],$b[3],$b[5],$b[7]));
	my $w = $rec[2]-$rec[0]; my $h = $rec[3]-$rec[1];
	$img_out->copyMerge($img, rand($width-$w),rand($height-$h), @rec[0,1], $w,$h, 0); # 25
	}
    $img->filledRectangle(0,0,$WIDTH-1,$HEIGHT-1,$c1);
    my @colors = (
	$img->colorAllocate(255,0,0),
	$img->colorAllocate(0,255,0),
	$img->colorAllocate(0,0,255),
	$img->colorAllocate(255,255,0),
	$img->colorAllocate(255,0,255),
	$img->colorAllocate(0,255,255),
	);
    $img->setThickness(3);

    for(1..30){
	my $c = $colors[rand(@colors)];
	my @coords = (rand($width),rand($height));
	while(1){
	    last if .2>rand;
	    my($dx,$dy) = (rand(30)-15, rand(20)-10);
	    $img->line($coords[0],$coords[1],$coords[0]+$dx,$coords[1]+$dy, $c);
	    $coords[0] += $dx;
	    $coords[1] += $dy;
	    }
	}

   $img_out->copyMerge($img, 0,0, 0,0, $width,$height, 0); # 25
      return $img_out;
    }

sub create_dash {
    return if defined $img_dash;
    $img_dash = new GD::Image(26, 3, 1);
    $img_dash->filledRectangle(0,0,25,2,$img_dash->colorAllocate(@bg_color));
    $img_dash->stringFT($img_dash->colorAllocate(@fg_color), $font, 20, 0, -1,6, "\x{2014}");
    }

sub create_root {
    return if defined $img_root;
    $img_root = new GD::Image(11,15, 1);
    $img_root->filledRectangle(0,0,10,14,$img_root->colorAllocate(@bg_color));
    $img_root->stringFT($img_root->colorAllocate(@fg_color), $font, 20, 0, -3,16, "\x{221A}");
    }

sub print_tokens {
    my $tokens = shift;
    $tokens = [$tokens] if ref $tokens eq '';
    my $img = new GD::Image($WIDTH,$HEIGHT,1);
    my $c1 = $img->colorAllocate(@bg_color);
    my $c2 = $img->colorAllocate(@fg_color);
    $img->filledRectangle(0,0,$WIDTH-1,$HEIGHT-1,$c1);
    my @bound = (20,$HEIGHT/2+$f_size,0,0,0); # [0]=x, [1]=ybaseline, [2]=width, [3]=height, [4]=ybaseline-y
    foreach (@$tokens){
	if(ref eq ''){
	    my @b = $img->stringFT($c2, $font, $f_size, 0, $bound[0]+$bound[2],$bound[1], $_);
	    $bound[2] = $bound[2] + $b[2]-$b[0];
	    $bound[3] = max($bound[1]-$b[5], $bound[4]) + max($bound[3]-$bound[4], $b[1]-$bound[1]);
	    $bound[4] = max($bound[1]-$b[5], $bound[4]);
	    next;
	    }
	if($_->{type} eq 'under'){
	    my($img_text,  @b1) = print_tokens($_->{above});
	    my($img_under, @b2) = print_tokens($_->{below});
	    my $width  = int(.5+$b2[2]*$f_sup);
	    my $height = int(.5+$b2[3]*$f_sup);
	    my $dstX = $b1[0]+($b1[2]-$width)/2+1;
	    my $dstY = $b1[1]+$b1[3]-$b1[4]+1;
	    $img_text->copyResized($img_under, $dstX,$dstY, $b2[0],$b2[1]-$b2[4], $width,$height, $b2[2],$b2[3]);
	    $b1[0] = min($b1[0], $dstX);
	    $b1[2] = max($b1[2], $width);
	    $b1[3] = $dstY+$height - ($b1[1]-$b1[4]);
	    append($img, \@bound, $img_text, \@b1);
	    }
	if($_->{type} eq 'frac'){
	    create_dash();
	    my($img_numer, @b1) = print_tokens($_->{above});
	    my($img_denom, @b2) = print_tokens($_->{below});
	    my $width_dash = max($b1[2], $b2[2]) + 4;
	    my $dstX = $bound[0] + $bound[2];
	    my $dstY = $bound[1] - 8;
	    $img->copyResized($img_dash, $dstX,$dstY, 0,0, $width_dash,3, 26,3);
	    $img->copy($img_numer, $dstX+($width_dash-$b1[2])/2,$dstY-1-$b1[3], $b1[0],$b1[1]-$b1[4], $b1[2],$b1[3]);
	    $img->copy($img_denom, $dstX+($width_dash-$b2[2])/2,$dstY+4,        $b2[0],$b2[1]-$b2[4], $b2[2],$b2[3]);
	    $bound[2] = $bound[2] + $width_dash;
	    $bound[3] = max($bound[3], $dstY+4+$b2[3]-($dstY-1-$b1[3]));
	    $bound[4] = max($bound[4], $bound[1]-($dstY-1-$b1[3]));
	    }
	if($_->{type} eq 'sup'){
	    my($img_exp, @b) = print_tokens($_->{above});
	    my $sup_height = max($f_supover*$f_size, $bound[4]-(1-$f_supover)*$f_size);
	    my $dstX = $bound[0]+$bound[2]-1;
	    my $dstY = $bound[1]-int(.5+$sup_height+$b[4]*$f_sup);
	    my $width = int(.5+$b[2]*$f_sup);
	    my $height = int(.5+$b[3]*$f_sup);
	    $img->copyResized($img_exp, $dstX,$dstY, $b[0],$b[1]-$b[4], $width,$height, $b[2],$b[3]);
	    my $over = max(0, $bound[1]-$bound[4]-$dstY+1);
	    $bound[2] += $width;
	    $bound[3] += $over;
	    $bound[4] += $over;
	    }
	if($_->{type} eq 'sqrt'){
	    create_dash();
	    create_root();
	    my($img_text, @b) = print_tokens($_->{below});
            $img_text->copyResized($img_root, $b[0]-12,$b[1]-$b[4], 0,0, 11,$b[3], 11,15);
            $img_text->copyResized($img_dash, $b[0]-1,$b[1]-$b[4]-3, 0,0, $b[2]+3,3, 26,3);
            $b[0]-=12; $b[2]+=14; $b[3]+=5; $b[4]+=5;
	    append($img, \@bound, $img_text, \@b);
	    }
	}
    return($img, @bound);
    }

sub append {
    my($img_dst, $bdst, $img_src, $bsrc) = @_;
    $img_dst->copy($img_src, $bdst->[0]+$bdst->[2],$bdst->[1]-$bsrc->[4], $bsrc->[0],$bsrc->[1]-$bsrc->[4], $bsrc->[2],$bsrc->[3]);
    $bdst->[2] = $bdst->[2] + $bsrc->[2];
    $bdst->[3] = max($bsrc->[4], $bdst->[4]) + max($bsrc->[3]-$bsrc->[4], $bdst->[3]-$bdst->[4]);
    $bdst->[4] = max($bsrc->[4], $bdst->[4]);
    }

sub max { $_[0]>$_[1] ? $_[0] : $_[1] }
sub min { $_[0]<$_[1] ? $_[0] : $_[1] }
sub MIN { @_==1 ? $_[0] : min(shift, MIN(@_)) }
sub MAX { @_==1 ? $_[0] : max(shift, MAX(@_)) }

1;
