drop table if exists results;
drop table if exists users;
drop table if exists tests;

create table tests (
    testid serial PRIMARY KEY,
    testfile varchar(128) NOT NULL CHECK (testfile <> ''),
    teststart timestamp with time zone NOT NULL,
    testend timestamp with time zone NOT NULL,
    testlength integer NOT NULL
);

insert into tests (testfile, teststart, testend, testlength)
       values ('mafexam2020p.html', '2020-06-23 18:00:00+03', '2020-06-23 19:00:00+03', 90*60);
insert into tests (testfile, teststart, testend, testlength)
       values ('maeexam2020p.html', '2020-07-03 18:00:00+03', '2020-07-03 19:00:00+03', 120*60);
insert into tests (testfile, teststart, testend, testlength)
       values ('mafexam2020p.html', '2020-06-29 10:30:00+03', '2020-06-29 17:36:00+03', 5*60);
insert into tests (testfile, teststart, testend, testlength)
       values ('maeexam2020p.html', '2020-06-29 10:45:00+03', '2020-06-29 19:50:00+03', 5*60);

create table users (
    userid serial PRIMARY KEY,
    username varchar(128) NOT NULL CHECK (username <> ''),
    userpassword varchar(128) NOT NULL CHECK (userpassword <> ''),
    usertestid integer NOT NULL,
    FOREIGN KEY (usertestid) REFERENCES tests (testid),
    UNIQUE (username, userpassword)
);

insert into users (username, userpassword, usertestid) values ('sgolovan@gmail.com', '1234567890', 3);
insert into users (username, userpassword, usertestid) values ('sgolovan@gmail.com', '0987654321', 4);

create table results (
    resultid serial PRIMARY KEY,
    resulttime timestamp with time zone NOT NULL,
    resultfinished integer NOT NULL,
    resultuserid integer NOT NULL,
    resultsessionid integer NOT NULL,
    gretest1 char(1) NULL,
    gretest2 char(1) NULL,
    gretest3 char(1) NULL,
    gretest4 char(1) NULL,
    gretest5 char(1) NULL,
    gretest6 char(1) NULL,
    gretest7 char(1) NULL,
    gretest8 char(1) NULL,
    gretest9 char(1) NULL,
    gretest10 char(1) NULL,
    gretest11 char(1) NULL,
    gretest12 char(1) NULL,
    gretest13 char(1) NULL,
    gretest14 char(1) NULL,
    gretest15 char(1) NULL,
    gretest16 char(1) NULL,
    gretest17 char(1) NULL,
    gretest18 char(1) NULL,
    gretest19 char(1) NULL,
    gretest20 char(1) NULL,
    gretest21 char(1) NULL,
    gretest22 char(1) NULL,
    gretest23 char(1) NULL,
    gretest24 char(1) NULL,
    gretest25 char(1) NULL,
    gretest26 char(1) NULL,
    gretest27 char(1) NULL,
    gretest28 char(1) NULL,
    gretest29 char(1) NULL,
    gretest30 char(1) NULL,
    gretest31 char(1) NULL,
    gretest32 char(1) NULL,
    test11 char(1) NULL,
    test12 char(1) NULL,
    test13 char(1) NULL,
    test14 char(1) NULL,
    test15 char(1) NULL,
    test16 char(1) NULL,
    test17 char(1) NULL,
    test18 char(1) NULL,
    test21 char(1) NULL,
    test22 char(1) NULL,
    test23 char(1) NULL,
    test24 char(1) NULL,
    test25 char(1) NULL,
    test26 char(1) NULL,
    test27 char(1) NULL,
    test28 char(1) NULL,
    test31 char(1) NULL,
    test32 char(1) NULL,
    test33 char(1) NULL,
    test34 char(1) NULL,
    test35 char(1) NULL,
    test36 char(1) NULL,
    test37 char(1) NULL,
    test38 char(1) NULL,
    test41 char(1) NULL,
    test42 char(1) NULL,
    test43 char(1) NULL,
    test44 char(1) NULL,
    test45 char(1) NULL,
    test46 char(1) NULL,
    test47 char(1) NULL,
    test48 char(1) NULL,
    FOREIGN KEY (resultuserid) REFERENCES users (userid)
);

grant select on tests to yaws;
grant select on users to yaws;
grant select,insert on results to yaws;
grant usage,select on sequence results_resultid_seq to yaws;

